/******************************************************************************
 *
 * Copyright (c) 1998,99 by Mindbright Technology AB, Stockholm, Sweden.
 *                 www.mindbright.se, info@mindbright.se
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 *****************************************************************************
 * $Author: mats $
 * $Date: 1999/01/25 21:15:07 $
 * $Name: rel0-98-1 $
 *****************************************************************************/
package mindbright.ssh;

import java.io.IOException;
import java.util.Hashtable;

public class SSHProtocolPlugin {

  static Hashtable plugins = new Hashtable();

  static {
    SSHProtocolPlugin.addPlugin("default", new SSHProtocolPlugin());
  }

  public static SSHProtocolPlugin getPlugin(String name) {
    SSHProtocolPlugin plugin = (SSHProtocolPlugin)plugins.get(name);
       return (SSHProtocolPlugin)plugins.get(name);
  }

  public static void addPlugin(String name, SSHProtocolPlugin plugin) {
    plugins.put(name, plugin);
  }

  public void initiate(SSHClient client) {
  }

  public SSHListenChannel localListener(int localPort, String remoteHost, int remotePort,
					SSHChannelController controller) throws IOException {
    return new SSHListenChannel(localPort, remoteHost, remotePort, controller);
  }

  public void remoteListener(int remotePort, String localHost, int localPort,
			     SSHChannelController controller) {
  }

}
